<template>
  <PageCard
    gradient
    :bordering="false"
    v-if="currency.ticker">
    <div v-if="estimated && minAmount">
      <div class="deposit_slider-wrapper">
        <div class="deposit_slider-label">
          <img
            class="deposit_slider-label-img"
            :src="currency.image"
            alt="">
          <div><span class="color-red">{{calculated}}</span>
            <span class="text-uppercase">{{currency.ticker}}</span></div>
        </div>
        <div class="deposit_slider-label">
          <img
            class="deposit_slider-label-img"
            style="filter: invert(1)"
            src="https://changenow.io/images/coins/eos.svg"
            alt="">
          <div><span class="color-green">{{parseInt(amount*rounding)/rounding}}</span> EOS</div>
        </div>
      </div>
      <BSlider
        :max="1000"
        :val="amount"
        :min="Math.round(estimated * minAmount * rounding) / rounding > 5 ? Math.round(Math.round(estimated * minAmount * rounding) / rounding) : 5"
        @change="changeVal"></BSlider>
      <div class="flex flex-center">
        <div class="deposit_email">
          <BInput
            :label="$t('deposit.payByCrypto.placeholder_email')"
            v-model="email">
            <template slot="append">
              <div
                class="input-point"
                :style="{backgroundColor: email ? isValidEmail ? '#36d052' : '#ff3737' : '#36d052'}"></div>
            </template>
          </BInput>
        </div>
      </div>
      <div class="flex flex-center">
        <Btn
          :disabled="disabled"
          @click="crossRoad"
          big>{{$t('deposit.btn')}}
        </Btn>
      </div>
      <SubPart3
        v-if="info.id"
        :info="info"
        :email="email"
        :amount="amount"></SubPart3>
      <Loader
        ref="loader"
        :timeToLoad="6000"
        :loadFunc="loadFunc">{{$t('deposit.creatingInvoice')}}
      </Loader>
    </div>
    <div
      class="pageCard-padding text-center"
      v-else>
      {{$t('deposit.gettingCurrency')}}
    </div>
  </PageCard>
</template>

<script>
  import PageCard from '~/components/UI/PageCard';
  import BSlider from '~/components/deposit/Slider';
  import Btn from '~/components/UI/BtnSign';
  import BInput from '~/components/UI/Input';
  import SubPart3 from './SubPart3';
  import Loader from '~/components/UI/Loader';
  import notification
    from '~/components/UI/Notification/main.js';
  import {Wallet} from '~/services/wallet/';
  import * as base58 from '~/components/utils/bs58.bundle.js';
  import config from '~/config';
  import RandExp from 'randexp';

  export default {
    name: "Step2",
    props: {
      currency: Object,
      val: {
        type: Number,
        default: 5
      }
    },
    data() {
      return {
        isValidEmail: false,
        dividerAmount: 10,
        rounding: 10000,
        amount: 0,
        email: '',
        estimated: 0,
        minAmount: 0,
        info: {},
        loading: false,
        disabled: true,
        inited: false,
        componentLoaded: false
      }
    },
    components: {
      PageCard,
      Btn,
      BSlider,
      BInput,
      SubPart3,
      Loader
    },
    computed: {
      isDemo() {
        return this.$store.state.common.demo;
      },
      tempAccountName() {
        return (!this.accountName || this.accountName === 'No account') ? this.$store.state.wallet.tempAccountName : this.accountName;
      },
      accountName() {
        return this.$store.state.wallet.accountName;
      },
      calculated() {
        return Math.ceil((1 / this.estimated) * this.amount * this.rounding) / this.rounding;
      }
    },
    methods: {
      changeVal(val) {
        this.disabled = false;
        this.amount = val;
        this.$emit('change', val);
      },
      crossRoad() {
        this.showLoader();
        if (!this.accountName || this.accountName === 'No account') {
          this.startCheckAccounts();
        } else {
          this.submit();
        }
      },
      loadFunc() {
        return this.loaded;
      },
      showLoader() {
        this.loaded = false;
        this.$nextTick(_ => {
          this.$refs['loader'].show();
        });
      },
      async submit({addressToSend = this.accountName, memo = '16bitgame'} = {}) {
        const amountToSend = this.calculated;
        const [err, res] = await this.$store.dispatch('deposit/send', {
          username: this.tempAccountName,
          address: addressToSend,
          amount: amountToSend,
          currency: this.currency.ticker,
          memo
        });
        if (err) {
          console.log(err);
          this.loaded = true;
          return notification.error({
            message: 'System message creating invoice - ' + err,
          });
        }
        this.info = Object.assign({
          amountToSend: amountToSend,
          email: this.email
        }, res);
        this.loaded = true;
        this.disabled = true;
      },
      getEstimatedRate({amount = 1, currency} = {}) {
        this.$store.dispatch('deposit/estimated', {
          from: currency.ticker,
          amount
        }).then(res => {
          this.disabled = false;
          this.estimated = res / this.dividerAmount;
          this.roundAmount();
          if (!this.inited) {
            this.inited = true;
            this.$nextTick(_ => {
              this.submit();
            });
          }
        }).catch(e => {
          return notification.error({
            message: e,
          });
        });
      },
      async getMinimumAmount({currency}) {
        const [err, res] = await this.$store.dispatch('deposit/minRate', currency.ticker);
        if (err) {
          notification.error({
            message: 'System message fetching rate - pair is inactive',
          });
          return err
        }
        this.minAmount = res.data.minAmount;
        return res.data;
      },
      roundAmount() {
        this.$nextTick(_ => {
          this.amount = Math.ceil(parseInt(this.amount * this.rounding) / this.rounding);
        });
      },
      startCheckAccounts() {
        this.showLoader();
        const privateKey = this.$store.state.wallet.privateKey || localStorage.getItem('private');
        const publicKeys = Wallet.privateToPublic(privateKey, '');
        this.checkUserName().then(res => {
          let owner = `${bs58.decode(Wallet.ownerPublicKey.slice(3)).toString('hex')}`;
          let active = `${bs58.decode(Wallet.activePublicKey.slice(3)).toString('hex')}`;
          const memo = `${this.tempAccountName}-${owner}-${active || owner}-5000-100-5`;
          this.submit({
            addressToSend: config.EOS.REG_CONTRACT,
            memo: memo
          });
        }).catch(e => {
          this.generateName(publicKeys[0]);
        });
      },
      createAccount(publicKey) {
        this.loadingText = 'Creating account...';
        const accountName = localStorage.getItem('accountname');
        this.$store.dispatch('user/create', {
          username: accountName,
          public: {
            owner: publicKey,
            active: publicKey,
          },
          signature: 'sign',
          timestamp: new Date().getTime()
        }).then(res => {
          this.$emit('close');
          this.clearLoader();
        }).catch(e => {
          this.clearLoader();
        });
      },
      checkUserName() {
        return new Promise((resolve, reject) => {
          this.error = false;
          this.$store.dispatch('signIn/checkUserName', this.tempAccountName).then(res => {
            this.disabled = true;
            this.error = true;
            reject();
          }).catch(e => {
            this.disabled = false;
            this.error = false;
            resolve();
          });
        });
      },
      generateName(publicKey) {
        const account = new RandExp(/[a-z1-5]{12}/);
        this.$store.commit('wallet/SET_TEMPACCOUNT_NAME', account.gen());
        this.$nextTick(_ => {
          this.checkUserName().then(res => {
            let owner = `${bs58.decode(Wallet.ownerPublicKey.slice(3)).toString('hex')}`;
            let active = `${bs58.decode(Wallet.activePublicKey.slice(3)).toString('hex')}`;
            const memo = `${this.tempAccountName}-${owner}-${active || owner}-5000-100-5`;
            this.createAccount({
              addressToSend: config.EOS.REG_CONTRACT,
              memo: `${this.tempAccountName}-${bs58.decode(publicKey).toString('hex')}`
            });
          }).catch(e => {
            this.generateName(publicKey);
          });
        });
      },
      changedCurrency() {
        if (!this.currency) return;
        this.getMinimumAmount({currency: this.currency}).then(res => {
          this.dividerAmount = res > this.dividerAmount ? res : this.dividerAmount;
          this.$nextTick(_ => {
            this.getEstimatedRate({amount: this.dividerAmount, currency: this.currency});
          });
        });
      }
    },
    mounted() {
      this.componentLoaded = true;
      if (this.isDemo) return;
      //this.changedCurrency();
    },
    watch: {
      'email': function () {
        const email = this.email.match(/[a-z0-9!#$%&'*+/=?^_‘{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_‘{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?/g);
        if (email && email.length) {
          this.disabled = false;
          this.isValidEmail = true;
        } else if (!this.email) {
          this.disabled = false;
          this.isValidEmail = true;
        } else {
          this.disabled = true;
          this.isValidEmail = false;
        }
      },
      'currency': {
        deep: true,
        handler() {
          if (this.isDemo || !this.componentLoaded) return;
          this.changedCurrency();
        }
      },
      val() {
        this.amount = this.val;
      }
    }
  }
</script>
